	var serverContext = document.getElementById("pinsafeUrl").value;
	var timeout = document.getElementById("timeout").value; //ms
	var pollAgain = true;
	

	function getXMLObject() //XML OBJECT
		{

			var xmlHttp = false;
			try {
				xmlHttp = new ActiveXObject("Msxml2.XMLHTTP") // For Old Microsoft Browsers
			} catch (e) {
				try {
					xmlHttp = new ActiveXObject("Microsoft.XMLHTTP") // For Microsoft IE 6.0+
				} catch (e2) {
					xmlHttp = false // No Browser accepts the XMLHTTP Object then false
				}
			}
			if (!xmlHttp && typeof XMLHttpRequest != 'undefined') {
				xmlHttp = new XMLHttpRequest(); //For Mozilla, Opera Browsers
			}
			return xmlHttp; // Mandatory Statement returning the ajax object created
		}

		var xmlhttp = new getXMLObject(); //xmlhttp holds the ajax object

		function ajaxFunction() {
			
			sid = document.getElementById("sessionId").value;

			if (xmlhttp) {

				urlString = serverContext + "/GETOtc?sessionid=" + sid + "&random="
						+ Math.round(Math.random() * 1000000);

				xmlhttp.open("GET", urlString, true); //will work with GET or POST

				xmlhttp.onreadystatechange = handleServerResponse;
				xmlhttp.setRequestHeader('Content-Type',
						'application/x-www-form-urlencoded');
				xmlhttp.send();
			}
		}
		
		function showTuringDependingOfMode(verificationMode) {
			if (verificationMode == "inboundmatch" || verificationMode =="inboundmessage") {
				if (document.getElementById("turing")!=null && document.getElementById("turing").style.display =="none") {
					document.getElementById("turing").style.display = "";
				}
			}
		}
		
		function sendOTCIfMatchMode(verificationMode, codeString) {
			if (verificationMode == "inboundmatch") {
        		document.getElementById("sessionId").value = codeString; 
        	}
		}

		function handleServerResponse() {
	
			if (xmlhttp.readyState == 4) {
				
				if (xmlhttp.status == 200) {
					var verificationMode = "";
					if(null != xmlhttp.responseXML.getElementsByTagName('verificationmode')[0].firstChild){
						verificationMode =  xmlhttp.responseXML.getElementsByTagName('verificationmode')[0].firstChild.nodeValue;
						showTuringDependingOfMode(verificationMode);
					}
				
	                var codeString="";
	               
	                if(null != xmlhttp.responseXML.getElementsByTagName('code')[0].firstChild){
	                	codeString  =  xmlhttp.responseXML.getElementsByTagName('code')[0].firstChild.nodeValue;
	                	sendOTCIfMatchMode(verificationMode, codeString);
	                	manageResponseOTC(codeString);
					}
				}
			}
	}

	function pollingEvent() {
		
		var startTime = document.getElementById("startTime").value;
		var currentTime = new Date().getTime();
		if (startTime && ((currentTime - startTime) > timeout)) {
			showTimeOutError();
			
		} else {	
			ajaxFunction();
		
			if (document.getElementById("sessionId").value.length!=0 && pollAgain) {
					// set to poll once per 5 seconds  
					t = setTimeout("pollingEvent()", 5000);
			}
		}
	}
	
	function cancelAuthentication() {
		document.getElementById("authState").value="cancelled";
		document.getElementById("oneTouchForm").submit();
		
		return false;
	}
	
	function startSession(startSessionUrl) {
		document.getElementById("oneTouchForm").action = startSessionUrl;
		document.getElementById("oneTouchForm").submit();
	}
	
	function validateFormAndStartSession(startSessionUrl) {
		if (document.getElementById("username").value!="") {
			startSession(startSessionUrl);
		}else {
			showErrorMessage("usernameEmpty");
		}
		return false;
	}
	
	function showErrorMessage(message) {
		document.getElementById("validationErrors").innerHTML = "<div class='error-box'>"+document.getElementById(message).value+"</div>";
		
	}
	
	function cancelAuthenticationAndRedirect() {
		document.getElementById("sessionId").value="";
		window.location = document.getElementById("vpnHomeURLFor2Stages").value;
		
		return false;
	}
		